#include "ch32x035_it.h"

#define __IRQ       __attribute__((interrupt(), used))
#define __IRQ_WEAK  __attribute__((interrupt(), weak))
#define __IRQ_NAKED __attribute__((naked, used))

void app_led1w_irq_handler(void);

__IRQ void NMI_Handler(void) {
    for (;;) {
        __WFI();
    }
}

__IRQ void HardFault_Handler(void) {
    for (;;) {
        __WFI();
    }
}

__IRQ_NAKED void Ecall_M_Mode_Handler(void) {
    asm volatile("j freertos_risc_v_exception_handler");
}

__IRQ_NAKED void SysTick_Handler(void) {
    asm volatile(
        "addi sp, sp, -4\n"   /* Push */
        "sw t0, 4(sp)\n"      /* Save t0 on stack */
        "li t0, 0xE000F004\n" /* SysTick->SR */
        "sw zero, 0(t0)\n"    /* Write 0 to clear */
        "lw t0, 4(sp)\n"      /* Restore t0 from stack */
        "addi sp, sp, 4\n"    /* Pop */
        "j freertos_risc_v_mtimer_interrupt_handler");
}

__IRQ void DMA1_Channel3_IRQHandler(void) {
    app_led1w_irq_handler();
}